Bug 803620 - backport vpmu fixes from upstream
backport vpmu fixes from upstream
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel (Show other bugs)
6.3
Unspecified Unspecified
unspecified Severity unspecified
: rc
: ---
Assigned To: Gleb Natapov
Virtualization Bugs
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-03-15 05:34 EDT by Gleb Natapov
Modified: 2013-12-08 19:56 EST (History)
7 users (show)

See Also:
Fixed In Version: kernel-2.6.32-254.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-06-20 04:34:46 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Gleb Natapov 2012-03-15 05:34:07 EDT
backport vpmu fixes from upstream
Comment 2 RHEL Product and Program Management 2012-03-15 08:09:49 EDT
This request was evaluated by Red Hat Product Management for inclusion
in a Red Hat Enterprise Linux maintenance release. Product Management has 
requested further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed 
products. This request is not yet committed for inclusion in an Update release.
Comment 3 Aristeu Rozanski 2012-03-22 13:33:00 EDT
Patch(es) available on kernel-2.6.32-254.el6
Comment 6 juzhang 2012-05-02 02:43:21 EDT
Hi, Gleb

Would you please provide an efficient way for qe to verify this issue? thanks
Comment 7 Gleb Natapov 2012-05-03 04:11:38 EDT
(In reply to comment #6)
> Hi, Gleb
> 
> Would you please provide an efficient way for qe to verify this issue? thanks

By running pmu unit test. Compare result before and after the patches.
Comment 8 juzhang 2012-05-03 07:24:12 EDT
Hi, Gleb

Still found 6 failures in fixed version, would you please elaborate on this? our results are expected?

Host box is sandy bridge


Fixed kernel(2.6.32-264.el6.x86_64)

Results:
enabling apic
paging enabled
cr0 = 80010011
cr3 = 7fff000
cr4 = 20
PMU version:         2
GP counters:         4
GP counter width:    48
Mask length:         7
Fixed counters:      3
Fixed counter width: 48
PASS: pmu core cycles-0
PASS: pmu core cycles-1
PASS: pmu core cycles-2
PASS: pmu core cycles-3
PASS: pmu instructions-0
PASS: pmu instructions-1
PASS: pmu instructions-2
PASS: pmu instructions-3
FAIL: pmu ref cycles-0
FAIL: pmu ref cycles-1
FAIL: pmu ref cycles-2
FAIL: pmu ref cycles-3
PASS: pmu llc refference-0
PASS: pmu llc refference-1
PASS: pmu llc refference-2
PASS: pmu llc refference-3
PASS: pmu llc misses-0
PASS: pmu llc misses-1
PASS: pmu llc misses-2
PASS: pmu llc misses-3
PASS: pmu branches-0
PASS: pmu branches-1
PASS: pmu branches-2
PASS: pmu branches-3
PASS: pmu branch misses-0
PASS: pmu branch misses-1
PASS: pmu branch misses-2
PASS: pmu branch misses-3
PASS: pmu fixed-0
PASS: pmu fixed-1
FAIL: pmu fixed-2
PASS: pmu rdpmc-0
PASS: pmu rdpmc fast-0
PASS: pmu rdpmc-1
PASS: pmu rdpmc fast-1
PASS: pmu rdpmc-2
PASS: pmu rdpmc fast-2
PASS: pmu rdpmc-3
PASS: pmu rdpmc fast-3
PASS: pmu rdpmc fixed-0
PASS: pmu rdpmc fixed fast-0
PASS: pmu rdpmc fixed-1
PASS: pmu rdpmc fixed fast-1
PASS: pmu rdpmc fixed-2
PASS: pmu rdpmc fixed fast-2
FAIL: pmu all counters-0
PASS: pmu overflow-0
PASS: pmu overflow status-0
PASS: pmu overflow status clear-0
PASS: pmu overflow irq-0
PASS: pmu overflow-1
PASS: pmu overflow status-1
PASS: pmu overflow status clear-1
PASS: pmu overflow irq-1
PASS: pmu overflow-2
PASS: pmu overflow status-2
PASS: pmu overflow status clear-2
PASS: pmu overflow irq-2
PASS: pmu overflow-3
PASS: pmu overflow status-3
PASS: pmu overflow status clear-3
PASS: pmu overflow irq-3
PASS: pmu overflow-4
PASS: pmu overflow status-4
PASS: pmu overflow status clear-4
PASS: pmu overflow irq-4
PASS: pmu cmask-0

67 tests, 6 failures



Unfixed kernel(2.6.32-252.el6.x86_64)

Results
nabling apic
paging enabled
cr0 = 80010011
cr3 = 7fff000
cr4 = 20
PMU version:         2
GP counters:         4
GP counter width:    48
Mask length:         7
Fixed counters:      3
Fixed counter width: 48
PASS: pmu core cycles-0
PASS: pmu core cycles-1
PASS: pmu core cycles-2
PASS: pmu core cycles-3
PASS: pmu instructions-0
PASS: pmu instructions-1
PASS: pmu instructions-2
PASS: pmu instructions-3
FAIL: pmu ref cycles-0
FAIL: pmu ref cycles-1
FAIL: pmu ref cycles-2
FAIL: pmu ref cycles-3
PASS: pmu llc refference-0
PASS: pmu llc refference-1
PASS: pmu llc refference-2
PASS: pmu llc refference-3
PASS: pmu llc misses-0
PASS: pmu llc misses-1
PASS: pmu llc misses-2
PASS: pmu llc misses-3
PASS: pmu branches-0
PASS: pmu branches-1
PASS: pmu branches-2
PASS: pmu branches-3
PASS: pmu branch misses-0
PASS: pmu branch misses-1
PASS: pmu branch misses-2
PASS: pmu branch misses-3
PASS: pmu fixed-0
PASS: pmu fixed-1
FAIL: pmu fixed-2
PASS: pmu rdpmc-0
unhandled excecption 13

Additional infos:
Host infos:

processor	: 5
vendor_id	: GenuineIntel
cpu family	: 6
model		: 42
model name	: Intel(R) Xeon(R) CPU E31280 @ 3.50GHz
stepping	: 7
cpu MHz		: 1600.000
cache size	: 8192 KB
physical id	: 0
siblings	: 8
core id		: 1
cpu cores	: 4
apicid		: 3
initial apicid	: 3
fpu		: yes
fpu_exception	: yes
cpuid level	: 13
wp		: yes
flags		: fpu vme de pse tsc msr pae mce cx8 apic mtrr pge mca cmov pat pse36 clflush dts acpi mmx fxsr sse sse2 ss ht tm pbe syscall nx rdtscp lm constant_tsc arch_perfmon pebs bts rep_good xtopology nonstop_tsc aperfmperf pni pclmulqdq dtes64 monitor ds_cpl vmx smx est tm2 ssse3 cx16 xtpr pdcm sse4_1 sse4_2 x2apic popcnt aes xsave avx lahf_lm ida arat epb xsaveopt pln pts dts tpr_shadow vnmi flexpriority ept vpid
Comment 9 Gleb Natapov 2012-05-03 07:35:33 EDT
(In reply to comment #8)
> Hi, Gleb
> 
> Still found 6 failures in fixed version, would you please elaborate on this?
> our results are expected?
Which version of unit test are you using. IIRC on rhel6 only one test should fail with latestunit test.

>
> FAIL: pmu all counters-0
That one (again IIRC).

> Unfixed kernel(2.6.32-252.el6.x86_64)
> 
> Results
>
> PASS: pmu rdpmc-0
> unhandled excecption 13
That's because of rdpmc bug that is fixed by the BZ.
Comment 10 juzhang 2012-05-03 21:52:21 EDT
(In reply to comment #9)
> (In reply to comment #8)
> > Hi, Gleb
> > 
> > Still found 6 failures in fixed version, would you please elaborate on this?
> > our results are expected?
> Which version of unit test are you using. IIRC on rhel6 only one test should
> fail with latestunit test.
git clone git://git.engineering.redhat.com/users/akivity/kvm-unit-tests.git

Did i use the right kvm-unit-test version?
Comment 11 Gleb Natapov 2012-05-04 05:57:13 EDT
(In reply to comment #10)
> (In reply to comment #9)
> > (In reply to comment #8)
> > > Hi, Gleb
> > > 
> > > Still found 6 failures in fixed version, would you please elaborate on this?
> > > our results are expected?
> > Which version of unit test are you using. IIRC on rhel6 only one test should
> > fail with latestunit test.
> git clone git://git.engineering.redhat.com/users/akivity/kvm-unit-tests.git
> 
> Did i use the right kvm-unit-test version?

This is what you need to use in theory, but I am not sure that this one is synced to latest upstream:
git://git.kernel.org/pub/scm/virt/kvm/kvm-unit-tests.git
Comment 12 juzhang 2012-05-11 02:28:41 EDT
> This is what you need to use in theory, but I am not sure that this one is
> synced to latest upstream:
> git://git.kernel.org/pub/scm/virt/kvm/kvm-unit-tests.git

Hi,Gleb

Tested using latest upstream, would you please have a look again and tell me whether the result is expected?


Results:
enabling apic
paging enabled
cr0 = 80010011
cr3 = 7fff000
cr4 = 20
PMU version:         2
GP counters:         4
GP counter width:    48
Mask length:         7
Fixed counters:      3
Fixed counter width: 48
PASS: pmu core cycles-0
PASS: pmu core cycles-1
PASS: pmu core cycles-2
PASS: pmu core cycles-3
PASS: pmu instructions-0
PASS: pmu instructions-1
PASS: pmu instructions-2
PASS: pmu instructions-3
PASS: pmu ref cycles-0
PASS: pmu ref cycles-1
PASS: pmu ref cycles-2
PASS: pmu ref cycles-3
PASS: pmu llc refference-0
PASS: pmu llc refference-1
PASS: pmu llc refference-2
PASS: pmu llc refference-3
PASS: pmu llc misses-0
PASS: pmu llc misses-1
PASS: pmu llc misses-2
PASS: pmu llc misses-3
PASS: pmu branches-0
PASS: pmu branches-1
PASS: pmu branches-2
PASS: pmu branches-3
PASS: pmu branch misses-0
PASS: pmu branch misses-1
PASS: pmu branch misses-2
PASS: pmu branch misses-3
PASS: pmu fixed-0
PASS: pmu fixed-1
FAIL: pmu fixed-2
PASS: pmu rdpmc-0
unhandled excecption 13
Comment 13 Gleb Natapov 2012-05-13 04:28:33 EDT
(In reply to comment #12)
> > This is what you need to use in theory, but I am not sure that this one is
> > synced to latest upstream:
> > git://git.kernel.org/pub/scm/virt/kvm/kvm-unit-tests.git
> 
> Hi,Gleb
> 
> Tested using latest upstream, would you please have a look again and tell me
> whether the result is expected?
> 
For the kernel without the fix for the BZ yes. Where is a result for fixed kernel?
Comment 14 juzhang 2012-05-14 23:29:18 EDT
(In reply to comment #13)
> (In reply to comment #12)
> > > This is what you need to use in theory, but I am not sure that this one is
> > > synced to latest upstream:
> > > git://git.kernel.org/pub/scm/virt/kvm/kvm-unit-tests.git
> > 
> > Hi,Gleb
> > 
> > Tested using latest upstream, would you please have a look again and tell me
> > whether the result is expected?
> > 
> For the kernel without the fix for the BZ yes. Where is a result for fixed
> kernel?
Sorry to miss fixed results. still found 2 failed results. would you please have a look again and tell me whether the result is expected? thanks

FAIL: pmu fixed-2
FAIL: pmu all counters-0

#uname -r
2.6.32-264.el6.x86_64

/usr/libexec/qemu-kvm -device testdev,chardev=testlog -chardev file,id=testlog,path=pmu.out -serial stdio -kernel x86/pmu.flat -cpu host
VNC server running on `::1:5900'
enabling apic
paging enabled
cr0 = 80010011
cr3 = 7fff000
cr4 = 20
PMU version:         2
GP counters:         4
GP counter width:    48
Mask length:         7
Fixed counters:      3
Fixed counter width: 48
PASS: pmu core cycles-0
PASS: pmu core cycles-1
PASS: pmu core cycles-2
PASS: pmu core cycles-3
PASS: pmu instructions-0
PASS: pmu instructions-1
PASS: pmu instructions-2
PASS: pmu instructions-3
PASS: pmu ref cycles-0
PASS: pmu ref cycles-1
PASS: pmu ref cycles-2
PASS: pmu ref cycles-3
PASS: pmu llc refference-0
PASS: pmu llc refference-1
PASS: pmu llc refference-2
PASS: pmu llc refference-3
PASS: pmu llc misses-0
PASS: pmu llc misses-1
PASS: pmu llc misses-2
PASS: pmu llc misses-3
PASS: pmu branches-0
PASS: pmu branches-1
PASS: pmu branches-2
PASS: pmu branches-3
PASS: pmu branch misses-0
PASS: pmu branch misses-1
PASS: pmu branch misses-2
PASS: pmu branch misses-3
PASS: pmu fixed-0
PASS: pmu fixed-1
FAIL: pmu fixed-2
PASS: pmu rdpmc-0
PASS: pmu rdpmc fast-0
PASS: pmu rdpmc-1
PASS: pmu rdpmc fast-1
PASS: pmu rdpmc-2
PASS: pmu rdpmc fast-2
PASS: pmu rdpmc-3
PASS: pmu rdpmc fast-3
PASS: pmu rdpmc fixed-0
PASS: pmu rdpmc fixed fast-0
PASS: pmu rdpmc fixed-1
PASS: pmu rdpmc fixed fast-1
PASS: pmu rdpmc fixed-2
PASS: pmu rdpmc fixed fast-2
FAIL: pmu all counters-0
PASS: pmu overflow-0
PASS: pmu overflow status-0
PASS: pmu overflow status clear-0
PASS: pmu overflow irq-0
PASS: pmu overflow-1
PASS: pmu overflow status-1
PASS: pmu overflow status clear-1
PASS: pmu overflow irq-1
PASS: pmu overflow-2
PASS: pmu overflow status-2
PASS: pmu overflow status clear-2
PASS: pmu overflow irq-2
PASS: pmu overflow-3
PASS: pmu overflow status-3
PASS: pmu overflow status clear-3
PASS: pmu overflow irq-3
PASS: pmu overflow-4
PASS: pmu overflow status-4
PASS: pmu overflow status clear-4
PASS: pmu overflow irq-4
PASS: pmu cmask-0

67 tests, 2 failures
Comment 15 Gleb Natapov 2012-05-15 04:32:17 EDT
(In reply to comment #14)
> (In reply to comment #13)
> > (In reply to comment #12)
> > > > This is what you need to use in theory, but I am not sure that this one is
> > > > synced to latest upstream:
> > > > git://git.kernel.org/pub/scm/virt/kvm/kvm-unit-tests.git
> > > 
> > > Hi,Gleb
> > > 
> > > Tested using latest upstream, would you please have a look again and tell me
> > > whether the result is expected?
> > > 
> > For the kernel without the fix for the BZ yes. Where is a result for fixed
> > kernel?
> Sorry to miss fixed results. still found 2 failed results. would you please
> have a look again and tell me whether the result is expected? thanks
> 
> FAIL: pmu fixed-2
> FAIL: pmu all counters-0
> 
Yes, this is expected result on rhel6 kernel.
Comment 16 Chao Yang 2012-05-16 01:24:31 EDT
As per Comment #12, #14, #15, moving to VERIFIED.
Comment 18 errata-xmlrpc 2012-06-20 04:34:46 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2012-0862.html

Note You need to log in before you can comment on or make changes to this bug.